#!/usr/bin/perl -w
use strict;

my @InLines = ('KN133N','KN20N','KN34','KN35','KN6');

my $chr = 'ChrX';
my $LocusName = 'yellow';
my $PosStart = 235001;
my $PosStop = 265000;
my $RevComp = 'No';

my $file = '';
my $unmask = '';
my $noadfilt = '';
my $OutputFile = '';
my $OutputName = '';
my $RangeStart = 0;
my $RangeStop = 0;
my @LineSeq = ();
my @InputSeq = ();
my @OutputSeq = ();
my $i = 0;
my $KiloRange = 0;
my $WinStart = -1;
my $f = 0;

for ($f = 0; $f < @InLines; $f++){
  $file = $InLines[$f] . "_" . $chr . "\.seq1k";
  open I, "<$file" 
    or die "Can't open $file\n";

  @InputSeq = ();
  @OutputSeq = ();
  $KiloRange = 0;
  $WinStart = -1;

  while (<I>){
    chomp;
    if ($PosStart <= $KiloRange + 1000){
      if ($WinStart < 0){
	$WinStart = $KiloRange;
      }
      @LineSeq = split(//, $_);
      @InputSeq = (@InputSeq, @LineSeq);
      last if ($PosStop <= $KiloRange + 1000);
    }
    $KiloRange += 1000;
  }
  close I;

  $RangeStart = $PosStart - $WinStart;
  $RangeStop = $PosStop - $WinStart;

  if ($RevComp eq 'Yes'){
    for ($i = ($RangeStop - 1); $i >= ($RangeStart - 1); $i--){
      if ($InputSeq[$i] eq 'A'){
	push @OutputSeq, 'T';
      }
      elsif ($InputSeq[$i] eq 'C'){
	push @OutputSeq, 'G';
      }
      elsif ($InputSeq[$i] eq 'G'){
	push @OutputSeq, 'C';
      }
      elsif ($InputSeq[$i] eq 'T'){
	push @OutputSeq, 'A';
      }
      else{
	push @OutputSeq, 'N';
      }
    }
  }
  else{
    for ($i = ($RangeStart - 1); $i < $RangeStop; $i++){
      push @OutputSeq, $InputSeq[$i];
    }
  }

  $OutputFile = $InLines[$f] . '_' . $LocusName . '.seq';
  $OutputName = '>' . $InLines[$f];
  open O, ">$OutputFile";
  print O "$OutputName\n";
  for ($i = 0; $i < @OutputSeq; $i++){
    print O $OutputSeq[$i];
#    if ($i % 1000 == 999){
#      print O "\n";
#    }
  }
}
